function Figures(muOrig, VOrig, lambdasOrig, mu, V, lambdas, ...
    cutoff, ps, P, ...
    AHisTot, MDLHisTot, studyName, aspectRatio)


nps=length(ps);
figure(1)
ahis = size(AHisTot,2)-1;
for node=1:nps
    if nps<=2  
        subplot(1,2,node);
    elseif nps<=6  
        subplot(2,3,node);
    elseif(nps<=8) 
        subplot(2,4,node);
    elseif(nps<=9) 
        subplot(3,3,node);
    else
      nc = round(sqrt(nps*2/1.5));
      nr = ceil(nps/nc);
      subplot(nr,nc,node);
    end
%  figure(11); subplot(1,1,1); node=8;
    plot(0:ahis, AHisTot(:,:,node)');
    ylabel('Node value');
%     xlabel('Step number');
    title(studyName);
end

his = length(MDLHisTot) - 1;
figure(2)
plot(0:his, MDLHisTot);
title(studyName);

figure(3);
koff = 0;
for k=1:3
    if aspectRatio>1.81 subplot(3,1,k);
    else subplot(1,3,k); end
    kk = k + koff;
    if P==length(muOrig) 
        muPlot = [muOrig muOrig(1)];
    else 
        muPlot = muOrig;
    end
    plot(muPlot,'r.'), hold on;
    plot(muPlot,':g')
    title(sprintf('Original %s %d', studyName, kk));
    axis equal, axis off;
    for nn=1:length(muOrig)
        plot([muOrig(nn), muOrig(nn) + 3*sqrt(lambdasOrig(kk))* VOrig(nn,kk)],'r-');
    end
    hold off;
end

figure(4);
for k=1:3
    if aspectRatio>1.81 subplot(3,1,k);
   else subplot(1,3,k); end
   rotFac = 1;
% for k=1:1
%     subplot(1,1,k);
%     rotFac = exp(j*pi*0.54);
% for k=1:2
%     subplot(1,2,k);
    kk = k + koff;
    if P==length(mu) 
        muPlot = [mu mu(1)];
    else 
        muPlot = mu;
    end
    plot(rotFac*muPlot,'r.'), hold on;
    plot(rotFac*muPlot,':g')
    title(sprintf('MDL %s %d',studyName,kk));
    axis equal, axis off;
    for nn=1:length(mu)
        plot(rotFac*[mu(nn), mu(nn) + 3*sqrt(lambdas(kk))* V(nn,kk)],'r-');
    end
    hold off;
end

figure(13);
clf
shi = 0.04;
% if studyName=='BumpBox' shi = 0.4;end
for k=1:3
    if aspectRatio>1.81 subplot(3,1,k);
    else subplot(1,3,k); end
    rotFac = 1;
% for k=1:1
%     subplot(1,1,k);
%     rotFac = exp(j*pi*0.54);

% for k=1:2
%     subplot(1,2,k);
    kk = k + koff;
    if P==length(muOrig) 
        muPlot = [muOrig muOrig(1)];
    else 
        muPlot = muOrig;
    end
    plot(rotFac*muPlot,'b'), hold on;
    plot(rotFac*muPlot,'r.')
    title(sprintf('Original %s %d',studyName,kk));
    axis equal, axis off;
    
    for sig = [-1 1] 
        mu2 = muOrig + sig*2*sqrt(lambdasOrig(kk))*VOrig(:,kk)';
        if P==length(mu) muPlot = [mu2 mu2(1)];else muPlot = mu2; end
        plot(shi*sig+rotFac*muPlot,'b'), hold on;
        plot(shi*sig+rotFac*muPlot,'r.')
    end
    hold off;
end

figure(14);
clf
shi = 0.04;
% if studyName=='BumpBox' shi = 0.4;end
for k=1:3
    if aspectRatio>1.81 subplot(3,1,k);
    else subplot(1,3,k); end
    rotFac = 1;
% for k=1:1
%     subplot(1,1,k);
%     rotFac = exp(j*pi*0.54);

% for k=1:2
%     subplot(1,2,k);
    kk = k + koff;
    if P==length(mu) 
        muPlot = [mu mu(1)];
    else 
        muPlot = mu;
    end
    plot(rotFac*muPlot,'b'), hold on;
    plot(rotFac*muPlot,'r.')
    title(sprintf('MDL %s %d',studyName,kk));
    axis equal, axis off;
    
    for sig = [-1 1] 
        mu2 = mu + sig*2*sqrt(lambdas(kk))*V(:,kk)';
        if P==length(mu) muPlot = [mu2 mu2(1)];else muPlot = mu2; end
        plot(shi*sig+rotFac*muPlot,'b'), hold on;
        plot(shi*sig+rotFac*muPlot,'r.')
    end
    hold off;
end

figure(5);
nn = length(lambdas);

[mdl, mdlTerms] = DescriptionLength(lambdasOrig, cutoff);
[mdlOrig, mdlTermsOrig] = DescriptionLength(lambdas, cutoff);

plot(1:nn, mdlTerms,'r-+', ...
     1:nn, mdlTermsOrig,'b-+')
title(studyName);

